Redmine - Defect #24473

CSV Export Very slow for issues with lots of Custom Fields
2016-11-28 12:23 - Stephane Evr

Status: New Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Performance Estimated time: 0.00 hour

Target version:

Resolution: Affected version:
Description
Environment:
Redmine version 3.3.0.stable
Ruby version 2.2.1-p85 (2015-02-26) [x86_64-1inux]
Rails version 4.2.6
Environment production
Database adapter Mysqgl2

So | tried to investigate why, when exporting an issue with lots of custom fields, my log file would look like this:

CACHE (0.0ms) SELECT ‘“issues’ .* FROM "issues’ WHERE “issues . id' = 94261 LIMIT 1 [["id"™, 94261
11

CACHE (0.0ms) SELECT “issues .* FROM "issues’ WHERE ‘issues’ . id’ = 94261 LIMIT 1 [["id", 942
61]]

CACHE (0.0ms) SELECT ‘“issues .* FROM " issues’ WHERE “issues . id = 94261 LIMIT 1 [prid", 942
6111

CACHE (0.0Oms) SELECT “issues .* FROM " issues WHERE “issues . id° = 94261 LIMIT 1 [rrid"™, 942
61]]

CACHE (0.0ms) SELECT ‘“issues’ .* FROM "issues’ WHERE “issues . id' = 94261 LIMIT 1 [rmid"™, 942
6111

CACHE (0.0ms) SELECT “issues .* FROM "issues’ WHERE ‘issues’ . id’ = 94261 LIMIT 1 [["id", 942
6111

CACHE (0.0ms) SELECT ‘“issues .* FROM " issues’ WHERE “issues . id = 94261 LIMIT 1 [prid", 942
CACHE (0.0Oms) SELECT “issues .* FROM " issues WHERE " issues . id" = 94261 LIMIT 1 [rrid"™, 942
61]]

CACHE (0.0ms) SELECT ‘“issues’ .* FROM "issues’ WHERE “issues . id' = 94261 LIMIT 1 [rmid"™, 942
6111

CACHE (0.0ms) SELECT “issues .* FROM "issues’ WHERE ‘issues’ . id’ = 94261 LIMIT 1 [["id", 942
6111

CACHE (0.0ms) SELECT ‘“issues .* FROM " issues’ WHERE “issues . id = 94261 LIMIT 1 [prid", 942
61]]

CACHE (0.0Oms) SELECT “issues .* FROM " issues WHERE " issues . id° = 94261 LIMIT 1 [rrid"™, 942
6111

CACHE (0.0ms) SELECT ‘“issues’ .* FROM "issues’ WHERE ‘issues . id' = 94261 LIMIT 1 [rmid"™, 942
61]]

CACHE (0.0ms) SELECT ‘“issues .* FROM "issues’ WHERE ‘issues’ . id' = 94261 LIMIT 1 [["id", 942
6111

CACHE (0.0ms) SELECT ‘“issues .* FROM "issues’ WHERE “issues . id = 94261 LIMIT 1 [prid", 942
61]]

CACHE (0.0Oms) SELECT “issues .* FROM " issues WHERE “issues . id" = 94261 LIMIT 1 [rrid"™, 942
61]]

CACHE (0.0ms) SELECT ‘“issues’ .* FROM "issues’ WHERE “issues . id' = 94261 LIMIT 1 [pmid"™, 942
6111

CACHE (0.0ms) SELECT “issues .* FROM "issues’ WHERE ‘issues’ . id’ = 94261 LIMIT 1 [["id", 942
6111

CACHE (0.0ms) SELECT ‘“issues .* FROM "issues’ WHERE “issues . id = 94261 LIMIT 1 [prid", 942
CACHE (0.0Oms) SELECT “issues .* FROM " issues WHERE “issues . id" = 94261 LIMIT 1 [r"id"™, 942
61]]

CACHE (0.0ms) SELECT ‘“issues’ .* FROM "issues’ WHERE “issues . id' = 94261 LIMIT 1 [pmid"™, 942
6111
CACHE (0.0ms) SELECT ‘“issues .* FROM "issues’ WHERE “issues . id’ = 94261 LIMIT 1 [rrid", 942
61]]

CACHE (0.0Oms) SELECT “issues .* FROM " issues WHERE “issues . id" = 94261 LIMIT 1 [rrid®™, 942
61]]

CACHE (0.0ms) SELECT ‘“issues’ .* FROM "issues’ WHERE “issues . id' = 94261 LIMIT 1 [rmid"™, 942
6111

CACHE (0.0ms) SELECT “issues .* FROM "issues’ WHERE ‘issues’ . id’ = 94261 LIMIT 1 [["id", 942
6111

There is one line per custom field apparently.
My investigation led this method (in lib/redmine/field_format.rb):

def formatted_custom_value (view, custom_value, html=false)
formatted_value (view, custom_value.custom_field, custom_value.value, custom_value.customized,
html)
# \
#THIS CALL
end

When custom_value.customized is called, this leads to the Customized object being loaded. Here, Customized is an issue, and it
would be reloaded once per custom field.

Some caching would be needed here, where we directly provide the customized object to this method, although | am not sure what's
best to do...

Related issues:

Related to Redmine - Feature #24477: CSV export feature for thousand of issues New
Related to Redmine - Patch #31076: Issues CSV / PDF export via ActiveJob New
Has duplicate Redmine - Defect #24755: Slow Queries because of Custom Fields Closed
History

#1 - 2016-11-28 16:18 - Stephane Evr

- File fix_cache_issues.patch added

| have attached a (dirty) patch which fixed the problem for me. The export time is basically twice faster.

#2 - 2016-11-29 02:57 - Toshi MARUYAMA
- Related to Feature #24477: CSV export feature for thousand of issues added

#3 - 2017-11-04 07:01 - Go MAEDA
- Category set to Performance

- Priority changed from High to Normal

#4 - 2017-11-04 07:05 - Go MAEDA
- Has duplicate Defect #24755: Slow Queries because of Custom Fields added

#5 - 2019-03-21 12:36 - Go MAEDA
- Related to Patch #31076: Issues CSV / PDF export via ActiveJob added

Files

fix_cache_issues.patch 6.57 KB 2016-11-28 Stephane Evr
